-- Test campsite_type
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(113);

set search_path to camper, public;

select has_table('campsite_type');
select has_pk('campsite_type' );
select table_privs_are('campsite_type', 'guest', array['SELECT']);
select table_privs_are('campsite_type', 'employee', array['SELECT']);
select table_privs_are('campsite_type', 'admin', array['SELECT', 'INSERT', 'UPDATE', 'DELETE']);
select table_privs_are('campsite_type', 'authenticator', array[]::text[]);

select has_column('campsite_type', 'campsite_type_id');
select col_is_pk('campsite_type', 'campsite_type_id');
select col_type_is('campsite_type', 'campsite_type_id', 'integer');
select col_not_null('campsite_type', 'campsite_type_id');
select col_hasnt_default('campsite_type', 'campsite_type_id');

select has_column('campsite_type', 'company_id');
select col_is_fk('campsite_type', 'company_id');
select fk_ok('campsite_type', 'company_id', 'company', 'company_id');
select col_type_is('campsite_type', 'company_id', 'integer');
select col_not_null('campsite_type', 'company_id');
select col_hasnt_default('campsite_type', 'company_id');

select has_column('campsite_type', 'slug');
select col_is_unique('campsite_type', 'slug');
select col_type_is('campsite_type', 'slug', 'uuid');
select col_not_null('campsite_type', 'slug');
select col_has_default('campsite_type', 'slug');
select col_default_is('campsite_type', 'slug', 'gen_random_uuid()');

select has_column('campsite_type', 'name');
select col_type_is('campsite_type', 'name', 'text');
select col_not_null('campsite_type', 'name');
select col_hasnt_default('campsite_type', 'name');

select has_column('campsite_type', 'media_id');
select col_is_fk('campsite_type', 'media_id');
select fk_ok('campsite_type', 'media_id', 'media', 'media_id');
select col_type_is('campsite_type', 'media_id', 'integer');
select col_not_null('campsite_type', 'media_id');
select col_hasnt_default('campsite_type', 'media_id');

select has_column('campsite_type', 'spiel');
select col_type_is('campsite_type', 'spiel', 'xml');
select col_not_null('campsite_type', 'spiel');
select col_has_default('campsite_type', 'spiel');
--select col_default_is('campsite_type', 'spiel', '');

select has_column('campsite_type', 'info');
select col_type_is('campsite_type', 'info', 'xml');
select col_not_null('campsite_type', 'info');
select col_has_default('campsite_type', 'info');
--select col_default_is('campsite_type', 'info', '');

select has_column('campsite_type', 'facilities');
select col_type_is('campsite_type', 'facilities', 'xml');
select col_not_null('campsite_type', 'facilities');
select col_has_default('campsite_type', 'facilities');
--select col_default_is('campsite_type', 'facilities', '');

select has_column('campsite_type', 'description');
select col_type_is('campsite_type', 'description', 'xml');
select col_not_null('campsite_type', 'description');
select col_has_default('campsite_type', 'description');
--select col_default_is('campsite_type', 'description', '');

select has_column('campsite_type', 'additional_info');
select col_type_is('campsite_type', 'additional_info', 'xml');
select col_not_null('campsite_type', 'additional_info');
select col_has_default('campsite_type', 'additional_info');
--select col_default_is('campsite_type', 'additional_info', '');

select has_column('campsite_type', 'max_campers');
select col_type_is('campsite_type', 'max_campers', 'integer');
select col_not_null('campsite_type', 'max_campers');
select col_hasnt_default('campsite_type', 'max_campers');

select has_column('campsite_type', 'overflow_allowed');
select col_type_is('campsite_type', 'overflow_allowed', 'boolean');
select col_not_null('campsite_type', 'overflow_allowed');
select col_has_default('campsite_type', 'overflow_allowed');
select col_default_is('campsite_type', 'overflow_allowed', false);

select has_column('campsite_type', 'ask_zone_preferences');
select col_type_is('campsite_type', 'ask_zone_preferences', 'boolean');
select col_not_null('campsite_type', 'ask_zone_preferences');
select col_has_default('campsite_type', 'ask_zone_preferences');
select col_default_is('campsite_type', 'ask_zone_preferences', false);

select has_column('campsite_type', 'check_in');
select col_type_is('campsite_type', 'check_in', 'text');
select col_not_null('campsite_type', 'check_in');
select col_has_default('campsite_type', 'check_in');
select col_default_is('campsite_type', 'check_in', '');

select has_column('campsite_type', 'check_out');
select col_type_is('campsite_type', 'check_out', 'text');
select col_not_null('campsite_type', 'check_out');
select col_has_default('campsite_type', 'check_out');
select col_default_is('campsite_type', 'check_out', '');

select has_column('campsite_type', 'bookable_nights');
select col_type_is('campsite_type', 'bookable_nights', 'int4range');
select col_not_null('campsite_type', 'bookable_nights');
select col_hasnt_default('campsite_type', 'bookable_nights');

select has_column('campsite_type', 'active');
select col_type_is('campsite_type', 'active', 'boolean');
select col_not_null('campsite_type', 'active');
select col_has_default('campsite_type', 'active');
select col_default_is('campsite_type', 'active', 'true');

select has_column('campsite_type', 'operating_dates');
select col_type_is('campsite_type', 'operating_dates', 'daterange');
select col_not_null('campsite_type', 'operating_dates');
select col_has_default('campsite_type', 'operating_dates');
select col_default_is('campsite_type', 'operating_dates', 'empty');

select has_column('campsite_type', 'position');
select col_type_is('campsite_type', 'position', 'integer');
select col_not_null('campsite_type', 'position');
select col_has_default('campsite_type', 'position');
select col_default_is('campsite_type', 'position', '2147483647');


set client_min_messages to warning;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company_host cascade;
truncate company_user cascade;
truncate company cascade;
truncate auth."user" cascade;
reset client_min_messages;

insert into auth."user" (user_id, email, name, password, cookie, cookie_expires_at)
values (1, 'demo@tandem.blog', 'Demo', 'test', '44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e', current_timestamp + interval '1 month')
     , (5, 'admin@tandem.blog', 'Demo', 'test', '12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524', current_timestamp + interval '1 month')
;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (4, 'Company 4', 'XX234', '', '666-666-666', 'b@b', '', '', '', '', '', '', 60, 7, 'FR', 'USD', 'ca')
;

insert into company_user (company_id, user_id, role)
values (2, 1, 'admin')
     , (4, 5, 'admin')
;

insert into company_host (company_id, host)
values (2, 'co2')
     , (4, 'co4')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (6, 2, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (8, 4, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (company_id, name, media_id, max_campers, bookable_nights)
values (2, 'Wooden lodge', 6, 7, '[1, 7]')
     , (4, 'Bungalow', 8, 6, '[2, 6]')
;

prepare campsite_type_data as
select company_id, name
from campsite_type
order by company_id, name;

set role guest;
select bag_eq(
	'campsite_type_data',
	$$ values (2, 'Wooden lodge')
	        , (4, 'Bungalow')
	$$,
	'Everyone should be able to list all campsite types across all companies'
);
reset role;

select set_cookie('44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e/demo@tandem.blog', 'co2');

select lives_ok(
	$$ insert into campsite_type(company_id, name, media_id, max_campers, bookable_nights) values (2, 'Another type', 6, 7, '[1, 7]') $$,
	'Admin from company 2 should be able to insert a new campsite type to that company.'
);

select bag_eq(
	'campsite_type_data',
	$$ values (2, 'Wooden lodge')
	        , (2, 'Another type')
	        , (4, 'Bungalow')
	$$,
	'The new row should have been added'
);

select lives_ok(
	$$ update campsite_type set name = 'Another' where company_id = 2 and name = 'Another type' $$,
	'Admin from company 2 should be able to update campsite type of that company.'
);

select bag_eq(
	'campsite_type_data',
	$$ values (2, 'Wooden lodge')
	        , (2, 'Another')
	        , (4, 'Bungalow')
	$$,
	'The row should have been updated.'
);

select lives_ok(
	$$ delete from campsite_type where company_id = 2 and name = 'Another' $$,
	'Admin from company 2 should be able to delete campsite type from that company.'
);

select bag_eq(
	'campsite_type_data',
	$$ values (2, 'Wooden lodge')
	        , (4, 'Bungalow')
	$$,
	'The row should have been deleted.'
);

select throws_ok(
	$$ insert into campsite_type (company_id, name, media_id, max_campers, bookable_nights) values (4, 'Another type', 6, 6, '[1, 7]') $$,
	'42501', 'new row violates row-level security policy for table "campsite_type"',
	'Admin from company 2 should NOT be able to insert new campsite types to company 4.'
);

select lives_ok(
	$$ update campsite_type set name = 'Nope' where company_id = 4 $$,
	'Admin from company 2 should not be able to update new campsite types of company 4, but no error if company_id is not changed.'
);

select bag_eq(
	'campsite_type_data',
	$$ values (2, 'Wooden lodge')
	        , (4, 'Bungalow')
	$$,
	'No row should have been changed.'
);

select throws_ok(
	$$ update campsite_type set company_id = 4 where company_id = 2 $$,
	'42501', 'new row violates row-level security policy for table "campsite_type"',
	'Admin from company 2 should NOT be able to move campsite types to company 4'
);

select lives_ok(
	$$ delete from campsite_type where company_id = 4 $$,
	'Admin from company 2 should NOT be able to delete campsite types from company 4, but not error is thrown'
);

select bag_eq(
	'campsite_type_data',
	$$ values (2, 'Wooden lodge')
	        , (4, 'Bungalow')
	$$,
	'No row should have been changed'
);

select throws_ok(
	$$ insert into campsite_type (company_id, name, media_id, max_campers, bookable_nights) values (2, '  ', 6, 5, '[1, 7]') $$,
	'23514', 'new row for relation "campsite_type" violates check constraint "name_not_empty"',
	'Should not be able to insert campsite types with a blank name.'
);

select throws_ok(
	$$ insert into campsite_type (company_id, name, media_id, max_campers, bookable_nights) values (2, 'Name', 6, 0, '[1, 7]') $$,
	'23514', 'new row for relation "campsite_type" violates check constraint "at_least_one_camper"',
	'Should not be able to insert campsite types with no campers allowed.'
);

select throws_ok(
	$$ insert into campsite_type (company_id, name, media_id, max_campers, bookable_nights) values (2, 'Name', 6, 1, '[0, 7]') $$,
	'23514', 'new row for relation "campsite_type" violates check constraint "at_least_one_night"',
	'Should not be able to insert campsite types that allows to book zero nights.'
);

select throws_ok(
	$$ insert into campsite_type (company_id, name, media_id, max_campers, bookable_nights) values (2, 'Name', 6, 1, '[1, 1)') $$,
	'23514', 'new row for relation "campsite_type" violates check constraint "at_least_one_night"',
	'Should not be able to insert campsite types with no bookable nights.'
);

reset role;


select *
from finish();

rollback;

